<?php
//--------------------------------------------------------------------
// *** RATEIT ***
// LAST UPDATE: 2009/05/30
// Version    : 1.31
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// control.php
//
//--------------------------------------------------------------------

$module_version = "1.31";

global $blogn_admin;
if (!$blogn_admin) exit;

$menu = array(1 => "ログ", "表示設定", "独自タグ", "インストール", "モジュール情報");
$loadtabs = "1";

require BLOGN_MODDIR.$module_name.'/function.php';
$logfile = BLOGN_MODDIR.$module_name.'/log.cgi';
$inifile = BLOGN_MODDIR.$module_name.'/config.cgi';

$rate_date0 = date("Ymd");
$rate_log0 = BLOGN_MODDIR.$module_name.'/log/'.$rate_date0.'.log';

$inis = file($inifile);
list($view, $number, $average) = explode(",", $inis[0]);

$logdata = file($logfile);
$logcount = count($logdata);
$i = 0;
for ($i = 0; $i < $logcount; $i++) {
	$logdata[$i] = explode(",", $logdata[$i]);
}

usort($logdata, "cmp");
$logdata = blogn_mod_rateit_log_sort($logfile);
$logcount = count($logdata);

switch($_POST["method"]) {
	case "edit":
	
		$view 		= $_POST["view"];
		$number 	= $_POST["number"];
		$average	= $_POST["average"];

		$fp = fopen($inifile, "w");
		fwrite($fp, "$view,$number,$average,\r\n",100);
		fclose($fp);

		$new_log = blogn_mod_rateit_log_today($logdata, $view, $number, $average);

		$fp = @fopen($rate_log0, "w") or die("Cannot Open File");
		flock($fp, LOCK_EX);
		fputs($fp, $new_log);
		fclose($fp);

		$message = "設定変更＆ログ作成完了";
		$loadtabs = "2";
		break;
	

	default:
		$message = "";
		$loadtabs = "1";
		break;
}


include BLOGN_MODDIR.$module_name.'/menu.php';

echo $js.'
<div class="blogn_main">

<div'.formatStyle($style["wrapper"]).'>
<h1'.formatStyle($style["mod_title"]).'>記事評価モジュール (ver'.$module_version.')</h1>

<!-- LEFT -->
<div'.formatStyle($style["coll"]).'>
<h2'.formatStyle($style["coll_h2"]).'>メニュー</h2>
<ul'.formatStyle($style["coll_ul"]).'>';

module_control_list($menu);

echo '
</ul>
<noscript><p'.formatStyle($style["nojs"]).'>※ Javascript 無効<br />メニュー内のテキストリンクは機能しないので、● をクリックしてナビゲートしてください。</p></noscript>
<p'.formatStyle($style["credit"]).'>Powered by<br /><a href="http://i-njoy.net/blog/" target="_blank"'.formatStyle($style["credit_a"]).'>nJOY BLOG</a></p>
</div>

<!-- RIGHT -->
<div'.formatStyle($style["colr"]).'>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("ログ", $menu).'">

<div class="blogn_bar">記事評価</div>
<table border="1" cellspacing="0" cellpadding="2" width="600">
<tr bgcolor="#e9e9e9"><th align="center" width="40">[ID]</th><th align="center" width="310">記事タイトル</th><th width="160" align="center">平均評価（5点満点中）</th><th align="center" width="40">評価数</th></tr>
';
	$i = 0;
	if ($logcount > 50) $logcount = 50;
	for ($i = 0; $i < $logcount; $i++) {
		$log = blogn_mod_db_log_load_for_editor($logdata[$i][0]);
		if ($log[0]) {
			$length = round($logdata[$i][4] * 25);
			echo '<tr><td align="center">'.$logdata[$i][0].'</td><td'.formatStyle($style["log_td"]).'><a href="index.php?e='.$logdata[$i][0].'" target="_blank">'.$log[1]["title"].'</a></td><td><img src="module/'.$module_name.'/bar_b.gif" width="'.$length.'" height="10" /> ('.number_format($logdata[$i][4], 2).')</td><td align="center">'.$logdata[$i][3].'</td></tr>
';
		} else {
			echo '<tr><td align="center">'.$logdata[$i][0].'</td><td colspan="2">この記事は削除されています。</td><td align="center">-</td></tr>
';	
		}
	}

	echo '</table>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("表示設定", $menu).'">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">

<div class="blogn_bar">表示設定</div>
<table border="1" cellspacing="0" cellpadding="2" width="600">
<tr bgcolor="#e9e9e9"><th width="100" align="center">項目</th><th align="center">説明</th><th width="100" align="center">設定</th></tr>
<tr><td align="center">表示件数</td><td'.formatStyle($style["log_td"]).'>ブログに表示される件数（最大）</td><td align="center"><select name="view"'.formatStyle($style["edit_select"]).'>';

for ($i = 1; $i < 51; $i++) {
	if ( $view == $i ) {
		echo '<option selected value="'.$i.'">'.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'</option>';
	}
}
echo '
</select></td></tr>
<tr><td align="center">評価件数</td><td'.formatStyle($style["log_td"]).'>次の設定値以上の評価数がある記事のみブログに表示</td><td align="center"><select name="number"'.formatStyle($style["edit_select"]).'>';
for ($i = 1; $i < 21; $i++) {
	if ( $number == $i ) {
		echo '<option selected value="'.$i.'">'.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'</option>';
	}
}
echo '
</select></td></tr>
<tr><td align="center">平均評価</td><td'.formatStyle($style["log_td"]).'>次の設定値以上の平均評価がある記事のみブログに表示</td><td align="center"><select name="average"'.formatStyle($style["edit_select"]).'>';
for ($i = 10; $i < 51; $i++) {
	if ( $average == $i ) {
		echo '<option selected value="'.$i.'">'.number_format($i * 0.1, 1).'</option>';
	}else{
		echo '<option value="'.$i.'">'.number_format($i * 0.1, 1).'</option>';
	}
}
echo '
</select></td></tr>
</table>
<input type="hidden" name="method" value="edit">
<input type="submit" value="設定変更"'.formatStyle($style["button"]).'> <span'.formatStyle($style["message"]).'>'.$message.'</span>
</form>
';

if (file_exists($rate_log0)) {
	$log_today = file($rate_log0);
	$count = count($log_today);
	if ($count) {
		echo '<p'.formatStyle($style["mod_p"]).'>上記の表示設定の条件に合う記事が <b>'.$count.'件</b> ありました。</p>
<div class="blogn_bar">表示内容</div>
<table border="1" cellspacing="0" cellpadding="2" width="600">
<tr bgcolor="#e9e9e9"><th align="center" width="40">[ID]</th><th align="center" width="310">記事タイトル</th><th width="160" align="center">平均評価（5点満点中）</th><th align="center" width="40">評価数</th></tr>';
		$i = 0;
		for ($i = 0; $i < $count; $i++) {
			list($id, $title, $total, $number, $average) = explode(",", $log_today[$i]);
			echo '<tr><td align="center">'.$id.'</td><td'.formatStyle($style["log_td"]).'>'.$title.'</td><td align="center">'.blogn_mod_rateit_convert_average($average).'</td><td align="center">'.$number.'</td></tr>';
		}
		echo '</table>';
	} else {
		echo '<div class="blogn_bar">表示内容</div>
<div'.formatStyle($style["mod"]).'>
<p'.formatStyle($style["mod_p"]).'>現在の条件で出力される内容はありません。</p><p'.formatStyle($style["mod_p"]).'>表示設定をもう一度見直してください。</p>
</div>';
	}
} else {
	echo '<div class="blogn_bar">表示内容</div>
<div'.formatStyle($style["mod"]).'>
<p'.formatStyle($style["mod_p"]).'>ブログ表示用ログが存在しません。「表示設定」で設定変更する事でログが作成されます。</p><p'.formatStyle($style["mod_p"]).'>評価一覧をブログに表示したくない場合は、設定をする必要はありません。</p>
</div>';
}
echo '
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("独自タグ", $menu).'">

<div class="blogn_bar">独自タグ</div>
<div'.formatStyle($style["mod"]).'>
<h2'.formatStyle($style["mod_h2"]).'>このモジュールで使える独自タグ（記事評価用）</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">独自タグ</th><th>説明</th><th width="50">補足</th></tr>
<tr><td>{RATEIT}</td><td>出力処理開始</td><td>必須</td></tr>
<tr><td>{RATEIT_ID}</td><td>記事ID（投稿フォーム内で使用）</td><td>必須</td></tr>
<tr><td>{RATEIT_CD}</td><td>認証コード（投稿フォーム内で使用）</td><td>必須</td></tr>
<tr><td>{RATEIT_ST}</td><td>平均評価の画像</td><td>-</td></tr>
<tr><td>{RATEIT_NO}</td><td>評価数</td><td>-</td></tr>
<tr><td>{/RATEIT}</td><td>出力処理終了</td><td>必須</td></tr>
</table>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで使える独自タグ（評価一覧用）</h2>
<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">独自タグ</th><th>説明</th><th width="50">補足</th></tr>
<tr><td>{RATE}</td><td>出力処理開始</td><td>必須</td></tr>
<tr><td>{RATELOOP}</td><td>ループ処理開始</td><td>必須</td></tr>
<tr><td>{RATE_LINK}</td><td>リンク開始</td><td>必須</td></tr>
<tr><td>{RATE_TITLE}</td><td>記事タイトル</td><td>必須</td></tr>
<tr><td>{/RATE_LINK}</td><td>リンク終了</td><td>必須</td></tr>
<tr><td>{RATE_ST}</td><td>平均評価の画像</td><td>-</td></tr>
<tr><td>{RATE_NO}</td><td>評価数</td><td>-</td></tr>
<tr><td>{/RATELOOP}</td><td>ループ処理終了</td><td>必須</td></tr>
<tr><td>{/RATE}</td><td>出力処理終了</td><td>必須</td></tr>
</table>

</div>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("インストール", $menu).'">
<div class="blogn_bar">インストール</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>インストール方法</h2>
<ol'.formatStyle($style["mod_list"]).'>
<li>「config.cgi」「lock」「log.cgi」のパーミッションを「666」等に変更する。</li>
<li>/log/ ディレクトリのパーミッションを「777」等に変更する。</li>
<li>スキンの HTML ファイルに記事評価用タグを追加する。</li>
<li>（オプション）スキンの HTML ファイルに記事評価一覧用タグを追加する。</li>
'.$mod_control["co_start"].'<li>必要に応じてモジュール管理画面から動作スイッチを ON にする必要があります。</li>'.$mod_control["co_end"].'
</ol>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンへの記述例（記事評価用）</h3>
<p'.formatStyle($style["mod_p"]).'>セレクトボックス型</p>
<pre'.formatStyle($style["pre"]).'>
{RATEIT}
記事を評価してください（★1つ＝悪い、★5つ＝良い）
&#60;form action="./index.php?mode=rateit" method="post" name="rateit"&#62;
&#60;select name="rating"&#62;
&#60;option value="5"&#62;★★★★★&#60;/option&#62;
&#60;option value="4"&#62;★★★★☆&#60;/option&#62;
&#60;option value="3" selected="selected"&#60;★★★☆☆&#60;/option&#62;
&#60;option value="2"&#62;★★☆☆☆&#60;/option&#62;
&#60;option value="1"&#62;★☆☆☆☆&#60;/option&#62;
&#60;/select&#62;
&#60;input type="hidden" name="id" value="{RATEIT_ID}" /&#62;
&#60;input type="hidden" name="cd" value="{RATEIT_CD}" /&#62;
&#60;input type="submit" name="submit" value="評価"&#62;
&#60;/form&#62;
この記事の平均評価： {RATEIT_ST} ({RATEIT_NO}人）
{/RATEIT}
</pre>

<p'.formatStyle($style["mod_p"]).'>ラジオボタン型</p>
<pre'.formatStyle($style["pre"]).'>
{RATEIT}
この記事は役に立ちましたか？
&#60;form action="./index.php?mode=rateit" method="post" name="rateit"&#62;
&#60;input type="radio" name="rating" value="1" /&#62;全然役に立たなかった
&#60;input type="radio" name="rating" value="2" /&#62;役に立たなかった
&#60;input type="radio" name="rating" value="3" checked="checked" /&#62;どちらでもない
&#60;input type="radio" name="rating" value="4" /&#62;役に立った
&#60;input type="radio" name="rating" value="5" /&#62;とても役に立った
&#60;input type="hidden" name="id" value="{RATEIT_ID}" /&#62;
&#60;input type="hidden" name="cd" value="{RATEIT_CD}" /&#62;
&#60;input type="submit" name="submit" value="評価"&#62;
&#60;/form&#62;
この記事の平均評価： {RATEIT_ST} ({RATEIT_NO}人）
{/RATEIT}
</pre>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンへの記述例（評価一覧用）</h3>
<pre'.formatStyle($style["pre"]).'>
{RATE}
&#60;ol&#62;
{RATELOOP}
    &#60;li&#62;{RATE_LINK}{RATE_TITLE}{/RATE_LINK} {RATE_ST} ({RATE_NO}人)&#60;/li&#62;
{/RATELOOP}
&#60;/ol&#62;
{/RATE}
</pre>
<p'.formatStyle($style["mod_p"]).'>評価一覧を表示するためには、「表示設定」から [設定変更] ボタンを押してブログ表示用ログを作成する必要があります。</p>

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("モジュール情報", $menu).'">
<div class="blogn_bar">モジュール情報</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>公式サイト</h2>
<p'.formatStyle($style["mod_p"]).'>もっと詳しい情報や最新版モジュールのダウンロードは「<a href="http://i-njoy.net/tips/plus_rtt.shtml" target="_blank">記事評価モジュール</a>」の解説ページからどうぞ。</p>
<p'.formatStyle($style["mod_p"]).'>最新情報は「<a href="http://i-njoy.net/blog/" target="_blank">nJOY BLOG</a>」から入手できます。</p>

<h2'.formatStyle($style["mod_h2"]).'>モジュール構成ファイル</h2>
<ul'.formatStyle($style["package"]).'>
<li'.formatStyle($style["pack_0"]).'>+ blognplus /</li>
<li'.formatStyle($style["pack_1"]).'>+ module /</li>
<li'.formatStyle($style["pack_2"]).'>+ rateit /</li>
<li'.formatStyle($style["pack_3"]).'>- bar_b.gif</li>
<li'.formatStyle($style["pack_3"]).'>- blank.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>config.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- control.php</li>
<li'.formatStyle($style["pack_3"]).'>- function.php</li>
<li'.formatStyle($style["pack_3"]).'>- index.html</li>
<li'.formatStyle($style["pack_3"]).'>- info.php</li>
<li'.formatStyle($style["pack_3"]).'>- install.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>lock</span></li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>log.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- menu.php</li>
<li'.formatStyle($style["pack_3"]).'>- rateit.php</li>
<li'.formatStyle($style["pack_3"]).'>- starf.gif</li>
<li'.formatStyle($style["pack_3"]).'>- starh.gif</li>
<li'.formatStyle($style["pack_3"]).'>- starn.gif</li>
<li'.formatStyle($style["pack_3"]).'>- style.php</li>
<li'.formatStyle($style["pack_3"]).'>- uninstall.php</li>
<li'.formatStyle($style["pack_3"]).'>- update.php</li>
<li'.formatStyle($style["pack_3"]).'>+ <span'.formatStyle($style["blue"]).'>log</span> /</li>
</ul>

<p'.formatStyle($style["mod_p"]).'><span'.formatStyle($style["red"]).'>赤文字のファイル</span>のパーミッションは「666」や「606」に変更してください。<br /><span'.formatStyle($style["blue"]).'>/log/ ディレクトリ</span>のパーミッションは「777」や「707」に変更してください。</p>

'.$mod_control["co_start"].'
<h2'.formatStyle($style["mod_h2"]).'>動作 ON/OFF</h2>
<p'.formatStyle($style["mod_p"]).'>モジュールをインストール後に、動作のオン・オフを切り替える必要があります。</p>
<dl'.formatStyle($style["mod_dl"]).'>
<dt>PC</dt><dd>PC 用スキンに独自タグを記述した場合、「PC」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
<dt>携帯</dt><dd>携帯 用スキンに独自タグを記述した場合、「携帯」欄 を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
</dl>

<h2'.formatStyle($style["mod_h2"]).'>優先順位</h2>
<p'.formatStyle($style["mod_p"]).'>特に制限はありません。</p>
'.$mod_control["co_end"].'

<h2'.formatStyle($style["mod_h2"]).'>その他の情報</h2>
<p'.formatStyle($style["mod_p"]).'>このモジュールは「<a href="http://i-njoy.net/tips/plus_xtg.shtml" target="_blank">タグ拡張モジュール</a>」と連携する事ができます。<br />「タグ拡張モジュール」をインストールすると以下の事が実現できます。</p>
<ul'.formatStyle($style["mod_list"]).'>
<li>ブログのトップページなど、記事別表示以外で記事評価ボタンを設置可能。</li>
</ul>

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

</div>
</div>
</div>';

?>
